/****************************************************************************************************************************************
SZODA v0.5b
by lordlsd <lordlsd at cracker dot hu>

Demonstracios eszkoz a VODKA-TONIC v0.5b programhoz. Hogy a buta jogaszok is elhiggyek, hogy az tenyleg csak egy baromi jo kep a 
baratnodrol.Tovabbi informacio a readme fileban.

A program es annak forraskodja barki altal dijmentesen hasznalhato, terjesztheto es modosithato. A modositasokrol tegyel emlitest a 
Changelog fileban, es modositas utan is hagyd meg az eredeti keszito(k) nevet, valamint a koszonetlistat!

Koszonet: voyager2

2004. Budapest, Hungary
****************************************************************************************************************************************/

#include <stdio.h>
#include <math.h>
#include <string.h>
#include <sys/stat.h>

#define VERSION "v0.5b"

void error(msg){
  printf("%s\n",msg);
  exit(1);
}

void print_info(){
  printf("Hasznalat: szoda [options] [carrier] [message] [key] [output]\n\n");
  printf("OPTIONS:\n");
  printf("-b\t\tCreate key to a BMP file\n");
  printf("-w\t\tCreate key to a WAV file\n");
  exit(1);
}

long file_size(file_name)
     char *file_name;
{
  struct stat stbuf;

  if (stat(file_name,&stbuf)==-1){
    error("File not found!");
  }
  return stbuf.st_size;
}

int is_bmp(bmp){
  int fr_bmp=open(bmp,0);
  unsigned char c[2];
  read(fr_bmp,&c,2);

  if (strncmp(c,"BM",2)==0){
    return 1;
  }else return 0;
  close(fr_bmp);
}

int is_wav(wav){
  int fr_wav=open(wav,0);
  unsigned char c[4];

  read(fr_wav,&c,4);

  if (strncmp(c,"RIFF",4)==0){
    lseek(fr_wav,8,0);
    read(fr_wav,&c,4);
    if(strncmp(c,"WAVE",4)==0){
      return 1;
    }else return 0;
  }else return 0;
  close(fr_wav);
}

int test_args(uzenet,hordozo,mode){
  if (mode==1){
    if (is_bmp(hordozo)==0) error("Ez nem egy BMP file!");
    if ((file_size(hordozo)-54)/8<file_size(uzenet)) error("Too small carrier!");
  }
  if (mode==2){
    if (is_wav(hordozo)==0) error("Ez nem egy WAV file!");
    if ((file_size(hordozo)-44)/8<file_size(uzenet)) error("Too small carrier!");
  }
  printf ("Arguments OK.\n");
}

/***************************************************OLVASO CUCCOK************************************************************************/
void bmp_read(hordozo,output)
{
  int fr_hordozo,fw_output,i;
  unsigned char u,h;
  
  fr_hordozo=open(hordozo,0);
  fw_output=creat(output,0700);
  lseek(fr_hordozo,54,0);
  
  i=0;
  u=0;
  h=0;

  while (read(fr_hordozo,&h,1)>0){
    if (i==8){
      write(fw_output,&u,1);
      i=0;
      u=0;
    }
    if(h%2 == 0){
      u=u*2;
    }else{
      u=(u*2)+1;
    }
    i++;
    
  }
  close(fr_hordozo);
  close(fw_output);
}


void wav_read(hordozo,output)
{
  int fr_hordozo,fw_output,i;
  unsigned char u,h;
  
  fr_hordozo=open(hordozo,0);
  fw_output=creat(output,0700);
  lseek(fr_hordozo,44,0);

  i=0;
  u=0;
  h=0;
  while (read(fr_hordozo,&h,1)>0){
    if (i==8){
      write(fw_output,&u,1);
      i=0;
      u=0;
    }
    if(h%2 == 0){
      u=u*2;
    }else{
      u=(u*2)+1;
    }
    i++;
  }
  close(fr_hordozo);
  close(fw_output);
}

/****************************************************************************************************************************************/

/*****************************************************MAIN FUNCTION**********************************************************************/
void co2(h2o,goal,output,key)
     char *key;
{
  int fr_h2o,fr_goal,fw_output;
  unsigned long size=file_size(goal),pos=0;
  unsigned char g,h,o,c;

  fr_h2o=open(h2o,0);
  fr_goal=open(goal,0);
  fw_output=creat(output,0644);
  
  for(c=4;c>0;c--){
    read(fr_h2o,&h,1);
    g=(size>>((c-1)*8))&255;
    o=h^g;
    write(fw_output,&o,1);
  }

  while(read(fr_goal,&g,1)>0){
    read(fr_h2o,&h,1); 
    o=g^h^key[pos%strlen(key)];
    write(fw_output,&o,1);
    pos++;
  }
  
}
/****************************************************************************************************************************************/

int main(argc,argv)
     int argc;
     char *argv[];
{
  printf("SZODA %s by lordlsd\n",VERSION);

  if (argc>=2){
    if ((strcmp(argv[1],"-b")==0)&&(argc==6)){
      test_args(3,2,1);
      bmp_read(argv[2],"h2o.tmp");
      co2("h2o.tmp",argv[3],argv[5],argv[4]);
      unlink("h2o.tmp");
      printf("%s succesfuly created",argv[5]);
    }
    else if ((strcmp(argv[1],"-w")==0)&&(argc==6)){
      test_args(3,2,2);
      wav_read(argv[2],"h2o.tmp");
      co2("h2o.tmp",argv[3],argv[5],argv[4]);
      unlink("h2o.tmp");
      printf("%s succesfuly created",argv[5]);
    }else print_info();
  }else print_info();
  return 0;
}
